---
title: CSS Animations tips and tricks
slug: Web/CSS/CSS_Animations/Tips
tags:
  - CSS
  - CSS Animations
  - Example
  - Guide
  - Reference
---
<div>{{cssref}}</div>

<p><span class="seoSummary">CSS Animations make it possible to do incredible things with the elements that make up your documents and apps. However, there are things you might want to do that aren't obvious, or clever ways to do things that you might not come up with right away. This article is a collection of tips and tricks we've found that may make your work easier, including how to run a stopped animation again.</span></p>

<h2 id="Run_an_animation_again">Run an animation again</h2>

<p>The <a href="/en-US/docs/Web/CSS/CSS_Animations">CSS Animations</a> specification doesn't offer a way to run an animation again. There's no magic <code>resetAnimation()</code> method on elements, and you can't even just set the element's {{cssxref("animation-play-state")}} to <code>"running"</code> again. Instead, you have to use clever tricks to get a stopped animation to replay.</p>

<p>Here's one way to do it that we feel is stable and reliable enough to suggest to you.</p>

<h3 id="HTML_content">HTML content</h3>

<p>First, let's define the HTML for a {{HTMLElement("div")}} we wish to animate and a button that will play (or replay) the animation.</p>

<pre class="brush: html">&lt;div class="box"&gt;
&lt;/div&gt;

&lt;div class="runButton"&gt;Click me to run the animation&lt;/div&gt;</pre>

<h3 id="CSS_content">CSS content</h3>

<p>Now we'll define the animation itself using CSS. Some CSS that's not important (the style of the "Run" button itself) isn't shown here, for brevity.</p>

<div class="hidden">
<pre class="brush: css">.runButton {
  cursor: pointer;
  width: 300px;
  border: 1px solid black;
  font-size: 16px;
  text-align: center;
  margin-top: 12px;
  padding-top: 2px;
  padding-bottom: 4px;
  color: white;
  background-color: darkgreen;
  font: 14px "Open Sans", "Arial", sans-serif;
}</pre>
</div>

<pre class="brush: css">@keyframes colorchange {
  0% { background: yellow }
  100% { background: blue }
}

.box {
  width: 100px;
  height: 100px;
  border: 1px solid black;
}

.changing {
  animation: colorchange 2s;
}</pre>

<p>There are two classes here. The <code>"box"</code> class is the basic description of the box's appearance, without any animation information included. The animation details are included in the <code>"changing"</code> class, which says that the {{cssxref("@keyframes")}} named <code>"colorchange"</code> should be used over the course of two seconds to animate the box.</p>

<p>Note that because of this, the box doesn't start with any animation effects in place, so it won't be animating.</p>

<h3 id="JavaScript_content">JavaScript content</h3>

<p>Next we'll look at the JavaScript that does the work. The meat of this technique is in the <code>play()</code> function, which is called when the user clicks on the "Run" button.</p>

<pre class="brush: js">function play() {
  document.querySelector(".box").className = "box";
  window.requestAnimationFrame(function(time) {
    window.requestAnimationFrame(function(time) {
      document.querySelector(".box").className = "box changing";
    });
  });
}</pre>

<p>This looks weird, doesn't it? That's because the only way to play an animation again is to remove the animation effect, let the document recompute styles so that it knows you've done that, then add the animation effect back to the element. To make that happen, we have to be creative.</p>

<p>Here's what happens when the <code>play()</code> function gets called:</p>

<ol>
 <li>The box's list of CSS classes is reset to <code>"box"</code>. This has the effect of removing any other classes currently applied to the box, including the <code>"changing"</code> class that handles animation. In other words, we're removing the animation effect from the box. However, changes to the class list don't take effect until the style recomputation is complete and a refresh has occurred to reflect the change.</li>
 <li>To be sure that the styles are recalculated, we use {{domxref("window.requestAnimationFrame()")}}, specifying a callback. Our callback gets executed just before the next repaint of the document. The problem for us is that because it's before the repaint, the style recomputation hasn't actually happened yet! So...</li>
 <li>Our callback cleverly calls <code>requestAnimationFrame()</code> a second time! This time, the callback is run before the next repaint, which is after the style recomputation has occurred. This callback adds the <code>"changing"</code> class back onto the box, so that the repaint will start the animation once again.</li>
</ol>

<p>Of course, we also need to add an event handler to our "Run" button so it'll actually do something:</p>

<pre class="brush: js">document.querySelector(".runButton").addEventListener("click", play, false);</pre>

<h3 id="Result">Result</h3>

<p>{{ EmbedLiveSample('Run_an_animation_again', 320, 160) }}</p>

<h2 id="Stopping_an_animation">Stopping an animation</h2>

<p>Removing the {{cssxref("animation-name")}} applied to an element will make it jump or cut to its next state. If instead you'd like the animation to complete and then come to a stop you have to try a different approach. The main tricks are:</p>

<ol>
 <li>Make your animation as self-contained as possible. This means you should not rely on <code>animation-direction: alternate</code>. Instead you should explicitly write a keyframe animation that goes through the full animation in one forward repetition.</li>
 <li>Use JavaScript and clear the animation being used when the <code>animationiteration</code> event fires.</li>
</ol>

<p>The following demo shows how you'd achieve the aforementioned JavaScript technique:</p>

<pre class="brush: css">.slidein {
  animation-duration: 5s;
  animation-name: slidein;
  animation-iteration-count: infinite;
}

.stopped {
  animation-name: none;
}

@keyframes slidein {
  0% {
    margin-left: 0%;
  }
  50% {
    margin-left: 50%;
  }
  100% {
    margin-left: 0%;
  }
}
</pre>

<pre class="brush: html">&lt;h1 id="watchme"&gt;Click me to stop&lt;/h1&gt;
</pre>

<pre class="brush: js">let watchme = document.getElementById('watchme')

watchme.className = 'slidein'
const listener = (e) =&gt; {
  watchme.className = 'slidein stopped'
}
watchme.addEventListener('click', () =&gt;
  watchme.addEventListener('animationiteration', listener, false)
)
</pre>

<p>Demo <a href="https://jsfiddle.net/morenoh149/5ty5a4oy/">https://jsfiddle.net/morenoh149/5ty5a4oy/</a></p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/Guide/CSS/Using_CSS_transitions">Using CSS transitions</a></li>
 <li>{{domxref("Window.requestAnimationFrame()")}}</li>
</ul>
